package com.zanxiang.game.back.serve.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zanxiang.game.back.serve.dao.mapper.GameTencentAppApiOrderSplitLogMapper;
import com.zanxiang.game.back.serve.pojo.entity.GameTencentAppApiOrderSplitLog;
import com.zanxiang.game.back.serve.pojo.vo.GameTencentAppApiOrderSplitLogVO;
import com.zanxiang.game.back.serve.service.IGameTencentAppApiOrderSplitLogService;
import com.zanxiang.module.util.NumberUtil;
import com.zanxiang.module.util.bean.BeanUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

@Slf4j
@Service
public class GameTencentAppApiOrderSplitLogServiceImpl extends ServiceImpl<GameTencentAppApiOrderSplitLogMapper, GameTencentAppApiOrderSplitLog>
implements IGameTencentAppApiOrderSplitLogService {

    @Override
    public List<GameTencentAppApiOrderSplitLogVO> listByOrderNo(Collection<String> orderNos) {
        if (CollectionUtils.isEmpty(orderNos)) {
            return Collections.emptyList();
        }
        return list(new LambdaQueryWrapper<GameTencentAppApiOrderSplitLog>()
                .in(GameTencentAppApiOrderSplitLog::getOrderNo, orderNos)
                .orderByAsc(GameTencentAppApiOrderSplitLog::getBackIndex)
        ).stream().map(this::toVOSimple).collect(Collectors.toList());
    }

    private GameTencentAppApiOrderSplitLogVO toVOSimple(GameTencentAppApiOrderSplitLog log) {
        if (log == null) {
            return null;
        }
        GameTencentAppApiOrderSplitLogVO vo = BeanUtil.copy(log, GameTencentAppApiOrderSplitLogVO.class);
        if (log.getSplitMoney() != null) {
            vo.setSplitMoney(NumberUtil.divide100(new BigDecimal(log.getSplitMoney())));
        }
        return vo;
    }
}
